SHA3 Class Reference

SHA3 message digest base class. More...

Inheritance diagram for SHA3:

## Public Member Functions

| SHA3 (unsigned int digestSize)
| Construct a SHA3. More...
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
void | Restart ()
| Restart the hash. More...
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Detailed Description

SHA3 message digest base class.

The Crypto++ implementation conforms to FIPS 202 version of SHA3 using F1600 with XOF d=0x06. Previous behavior (XOF d=0x01) is available in Keccak classes.

SHA3 is the base class for SHA3_224, SHA3_256, SHA3_384 and SHA3_512. Library users should instantiate a derived class, and only use SHA3 as a base class reference or pointer.

See also
  Keccak, SHA3_224, SHA3_256, SHA3_384 and SHA3_512.

Since
  Crypto++ 5.6.2

Definition at line 28 of file sha3.h.

## Constructor & Destructor Documentation

## SHA3()

SHA3::SHA3 | ( | unsigned int | digestSize | ) |

inline

Construct a SHA3.

Parameters

  digestSize | the digest size, in bytes

SHA3 is the base class for SHA3_224, SHA3_256, SHA3_384 and SHA3_512. Library users should instantiate a derived class, and only use SHA3 as a base class reference or pointer.

Definition at line 36 of file sha3.h.

## Member Function Documentation

## DigestSize()

unsigned int SHA3::DigestSize | ( |  | ) | const

inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 37 of file sha3.h.

## AlgorithmName()

std::string SHA3::AlgorithmName | ( |  | ) | const

inline virtual

Provides the name of this algorithm.

Returns
  the standard algorithm name

The standard algorithm name can be a name like AES or AES/GCM. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Note
  AlgorithmName is not universally implemented yet

Reimplemented from Algorithm.

Definition at line 38 of file sha3.h.

## OptimalDataAlignment()

unsigned int SHA3::OptimalDataAlignment | ( |  | ) | const

inline virtual

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

Reimplemented from HashTransformation.

Definition at line 39 of file sha3.h.

## Update()

void SHA3::Update | ( | const byte * | input,
|  | size_t | length
| ) |  |

virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

Definition at line 252 of file sha3.cpp.

## Restart()

void SHA3::Restart | ( |  | ) |

virtual

Restart the hash.

Discards the current state, and restart for a new message

Reimplemented from HashTransformation.

Definition at line 274 of file sha3.cpp.

## TruncatedFinal()

void SHA3::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |

virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() call Final() and then copies digestSize bytes to digest

TruncatedFinal() restarts the hash for the next message.

Precondition
  `COUNTOF(digest) == DigestSize()` or `COUNTOF(digest) == HASH::DIGESTSIZE` ensures the output byte buffer is large enough for the digest.

Implements HashTransformation.

Definition at line 280 of file sha3.cpp.

The documentation for this class was generated from the following files:

- sha3.h
- sha3.cpp